library JassAccelerator;

{$mode objfpc}{$H+}

uses
	LazLogger, SysUtils,

	Windows,

	wc3main,
 	wc3jassvm,

	DebugUtils, SharedMemory,
	jassvmhooks, myjassvm, data;

exports
	SetTransformJassCodeHandleFunction,
	GetTransformJassCodeHandleFunction,
	ResetTransformJassCodeHandleFunction;

function PublishModulePath(hModule: HMODULE; Key: String): Boolean;
var
	UniqueName: String;
	hStorage: Handle;
begin
	UniqueName:= Format('%s.library_path.%d', [Key, GetCurrentProcessId]);
	Result:= CreateSharedConstantString(
		UniqueName,
		GetModuleName(hModule),
		hStorage
	);
end;

begin
	PublishModulePath(HINSTANCE, 'xgm.icefog.jass_accelerator');
	wc3main.Init(GetModuleHandle('game.dll'));
	jassvmhooks.pOnInstanceCreated:= @myjassvm.OnInstanceCreated;
	jassvmhooks.pOnInstanceDestroying:= @myjassvm.OnInstanceDestroying;
	jassvmhooks.pOnInstanceInit:= @myjassvm.OnInstanceInit;
	jassvmhooks.pOnInstanceResumeExecution:= @myjassvm.OnInstanceResumeExecution;
	jassvmhooks.pOnExecuteFunctionByName:= @myjassvm.OnInstanceExecuteFunctionByName;
	jassvmhooks.pOnExecuteFunctionByHandle:= @myjassvm.OnInstanceExecuteFunctionByHandle;
	jassvmhooks.pOnInstanceGetStringHandle:= @myjassvm.OnInstanceGetStringHandle;
	jassvmhooks.pOnEnableVarChangeEvent:= @myjassvm.pOnEnableVarChangeEvent;
end.

