unit fast_float;

{$mode objfpc}{$H+}

interface

const
	DEFAULT_EPSILON: Single = 0.001;

type

	{ TFloatWar3 }

	TFastFloatWar3 = object
	public
		Value: Single;
	public
		function IsApproximatelyEqualTo(const AOther: TFastFloatWar3; epsilon: Single = 0.001): Boolean;
		function Abs: TFastFloatWar3;
	end;
	PFastFloatWar3 = ^TFastFloatWar3;

operator + (const A, B: TFastFloatWar3): TFastFloatWar3;
operator - (const A, B: TFastFloatWar3): TFastFloatWar3;
operator - (const A: TFastFloatWar3): TFastFloatWar3;
operator * (const A, B: TFastFloatWar3): TFastFloatWar3;
operator / (const A, B: TFastFloatWar3): TFastFloatWar3;
operator > (const A, B: TFastFloatWar3): Boolean;
operator >= (const A, B: TFastFloatWar3): Boolean;
operator < (const A, B: TFastFloatWar3): Boolean;
operator <= (const A, B: TFastFloatWar3): Boolean;
operator = (const A, B: TFastFloatWar3): Boolean;

operator explicit (const A: Int32): TFastFloatWar3;
operator explicit (const A: Single): TFastFloatWar3;
operator explicit (const A: TFastFloatWar3): Single;

implementation

operator + (const A, B: TFastFloatWar3): TFastFloatWar3;
begin
	Result.Value:= A.Value + B.Value;
end;

operator - (const A, B: TFastFloatWar3): TFastFloatWar3;
begin
	Result.Value:= A.Value - B.Value;
end;

operator - (const A: TFastFloatWar3): TFastFloatWar3;
begin
	Result.Value:= -A.Value;
end;

operator * (const A, B: TFastFloatWar3): TFastFloatWar3;
begin
	Result.Value:= A.Value * B.value;
end;

operator / (const A, B: TFastFloatWar3): TFastFloatWar3;
begin
	Result.Value:= A.Value / B.Value;
end;

operator > (const A, B: TFastFloatWar3): Boolean;
begin
	Result:= A.Value > B.Value;
end;

operator >= (const A, B: TFastFloatWar3): Boolean;
begin
	Result:= A.Value >= B.Value;
end;

operator < (const A, B: TFastFloatWar3): Boolean;
begin
	Result:= A.Value < B.Value;
end;

operator <= (const A, B: TFastFloatWar3): Boolean;
begin
	Result:= A.Value <= B.Value;
end;

operator = (const A, B: TFastFloatWar3): Boolean;
begin
	Result:= A.Value = B.Value;
end;

operator explicit(const A: Int32): TFastFloatWar3;
begin
	Result.Value:= Single(A);
end;

operator explicit(const A: Single): TFastFloatWar3;
begin
	Result.Value:= A;
end;

operator explicit(const A: TFastFloatWar3): Single;
begin
	Result:= A.Value;
end;

{ TFastFloatWar3 }

function TFastFloatWar3.IsApproximatelyEqualTo(const AOther: TFastFloatWar3;
	epsilon: Single): Boolean;
begin
	Result:= (Self - AOther).Abs().Value <= epsilon;
end;

function TFastFloatWar3.Abs: TFastFloatWar3;
begin
	Result.Value:= System.Abs(Value);
end;

end.


