unit wc3memory;

{$mode objfpc}{$H+}

interface

const
	STORM_NAME = 'storm.dll';

function SMemAlloc(Size: PtrUInt; SourceFile: PChar; SourceLine: Integer; Flags: Dword): Pointer; stdcall; external STORM_NAME index 401;
function SMemFree(Memory: Pointer; SourceFile: PChar; SourceLine: Integer; Flags: Dword): Pointer; stdcall; external STORM_NAME index 403;
function SMemReAlloc(Memory: Pointer; NewSize: PtrUInt; SourceFile: PChar; SourceLine: Integer; Flags: Dword): Pointer; stdcall; external STORM_NAME index 405;

function Allocate(Size: PtrUInt): Pointer;
function ReAllocate(Memory: Pointer; NewSize: PtrUInt): Pointer;
procedure Free(Memory: Pointer);
function CloneString(s: PChar): PChar;

implementation

uses
	LazTracer;

function GetStackTraceLong(UseCache: boolean): string;
var
  bp: Pointer;
  addr: Pointer;
  oldbp: Pointer;
  CurAddress: String;
begin
  Result:='';
  { retrieve backtrace info }
  bp:=get_caller_frame(get_frame);
  while bp<>nil do begin
    addr:=get_caller_addr(bp);
    CurAddress:=GetLineInfo(addr,UseCache);
    //DebugLn('GetStackTrace ',CurAddress);
    Result:=Result+CurAddress+LineEnding;
    oldbp:=bp;
    bp:=get_caller_frame(bp);
    if (bp<=oldbp) or (bp>(StackBottom + StackLength)) then
      bp:=nil;
  end;
end;

procedure RemoveInvalidChars(var s: String);
var
	i: Integer;
begin
	for i:= 0 to High(s) do begin
		if s[i] in [#13, #10] then begin
			s[i]:= '~';
		end;
	end;
end;

function Allocate(Size: PtrUInt): Pointer;
//var
//	trace: String;
begin
	//trace:= GetStackTraceLong(True);
	//RemoveInvalidChars(trace);
	//if Length(trace) >= 256 then begin
	//	trace[256]:= #0;
	//end;
	//Result:= SMemAlloc(Size, PChar(trace), $4D564A4F, 0);
	Result:= SMemAlloc(Size, nil, 0, 0);
end;

function ReAllocate(Memory: Pointer; NewSize: PtrUInt): Pointer;
begin
	Result:= SMemReAlloc(Memory, NewSize, nil, 0, 0);
end;

procedure Free(Memory: Pointer);
begin
	SMemFree(Memory, nil, 0, 0);
end;

function CloneString(s: PChar): PChar;
var
	Length: Integer;
begin
	Length:= StrLen(s);
	Result:= Allocate(Length + 1);
	Move(s^, Result^, Length);
	Result[Length]:= #0;
end;

end.

